Simplifying legacy args handling
Simplifying legacy args handling

#!/bin/bash #!/bin/bash
# #
# A very simple BASH script to take an input video and split it down into Segments # A very simple BASH script to take an input video and split it down into Segments
# before creating an M3U8 Playlist, allowing the file to be served using HLS # before creating an M3U8 Playlist, allowing the file to be served using HLS
# #
# #
   
###################################################################################### ######################################################################################
# #
# Copyright (c) 2013, Ben Tasker # Copyright (c) 2013, Ben Tasker
# All rights reserved. # All rights reserved.
# #
# Redistribution and use in source and binary forms, with or without modification, # Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met: # are permitted provided that the following conditions are met:
# #
# Redistributions of source code must retain the above copyright notice, this # Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer. # list of conditions and the following disclaimer.
# #
# Redistributions in binary form must reproduce the above copyright notice, this # Redistributions in binary form must reproduce the above copyright notice, this
# list of conditions and the following disclaimer in the documentation and/or # list of conditions and the following disclaimer in the documentation and/or
# other materials provided with the distribution. # other materials provided with the distribution.
# #
# Neither the name of the {organization} nor the names of its # Neither the name of Ben Tasker nor the names of his
# contributors may be used to endorse or promote products derived from # contributors may be used to endorse or promote products derived from
# this software without specific prior written permission. # this software without specific prior written permission.
# #
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE # WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR # DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES # ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; # (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON # LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT # ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# #
###################################################################################### ######################################################################################
   
# Basic config # Basic config
OUTPUT_DIRECTORY='./output' OUTPUT_DIRECTORY=${OUTPUT_DIRECTORY:-'./output'}
   
# Change this if you want to specify a path to use a specific version of FFMPeg # Change this if you want to specify a path to use a specific version of FFMPeg
FFMPEG='ffmpeg' FFMPEG=${FFMPEG:-'ffmpeg'}
   
  # Number of threads which will be used for transcoding. With newer FFMPEGs and x264
  # encoders "0" means "optimal". This is normally the number of CPU cores.
  NUMTHREADS=${NUMTHREADS:-"0"}
   
  # Video codec for the output video. Will be used as an value for the -vcodec argument
  VIDEO_CODEC=${VIDEO_CODEC:-"libx264"}
   
  # Video codec for the output video. Will be used as an value for the -acodec argument
  AUDIO_CODEC=${AUDIO_CODEC:-"libfdk_aac"}
   
  # Additional flags for ffmpeg
  FFMPEG_FLAGS=${FFMPEG_FLAGS:-""}
   
# Lets put our functions here # Lets put our functions here
   
   
## Output the script's CLI Usage ## Output the script's CLI Usage
# #
# #
function print_usage(){ function print_usage(){
   
cat << EOM cat << EOM
HTTP Live Stream Creator HTTP Live Stream Creator
Version 1 Version 1
   
Copyright (C) 2013 B Tasker Copyright (C) 2013 B Tasker, D Atanasov
Released under BSD 3 Clause License Released under BSD 3 Clause License
See LICENSE See LICENSE
   
   
Usage: HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output'] Usage: HLS-Stream-Creator.sh -i [inputfile] -s [segmentlength(seconds)] -o [outputdir]
   
  -i Input file
  -s Segment length (seconds)
  -o Output directory (default: ./output)
   
  Deprecated Legacy usage:
  HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output']
   
EOM EOM
   
exit exit
   
} }
   
  # Get the input data
   
## Create the Initial M3U8 file including the requisite headers # This exists to maintain b/c
# LEGACY_ARGS=1
# Usage: create_m3u8 streamname segmentlength  
#  
function create_m3u8(){  
   
# We'll add some more headers in a later version, basic support is all we need for now # If even one argument is supplied, switch off legacy argument style
# The draft says we need CRLF so we'll use SED to ensure that happens while getopts "i:o:s:" flag
cat << EOM | sed 's/$/\r/g' > $OUTPUT_DIRECTORY/$1.m3u8 do
#EXTM3U LEGACY_ARGS=0
#EXT-X-TARGETDURATION:$2 case "$flag" in
#EXT-X-MEDIA-SEQUENCE:0 i) INPUTFILE="$OPTARG";;
#EXT-X-VERSION:3 o) OUTPUT_DIRECTORY="$OPTARG";;
EOM s) SEGLENGTH="$OPTARG";;
} esac
  done
   
   
## Append a movie segment to the M3U8 if [ "$LEGACY_ARGS" == "1" ]
# then
# Usage: append_segment streamname SegmentLength(Seconds) SegmentFilename # Old Basic Usage is
# # cmd.sh inputfile segmentlength
function append_segment(){  
   
cat << EOM | sed 's/$/\r/g' >> $OUTPUT_DIRECTORY/$1.m3u8 INPUTFILE=${INPUTFILE:-$1}
#EXTINF:$2 SEGLENGTH=${SEGLENGTH:-$2}
$3 if ! [ -z "$3" ]
EOM then
} OUTPUT_DIRECTORY=$3
  fi
  fi
   
   
## Close the M3U8 file  
#  
# Found that ffplay skips the first few segments if this isn't included.  
#  
# Usage: close_m3u8 streamname  
#  
function close_m3u8(){  
cat << EOM | sed 's/$/\r/g' >> $OUTPUT_DIRECTORY/$1.m3u8  
#EXT-X-ENDLIST  
EOM  
}  
   
   
# The fun begins! Think of this as function main  
   
   
# Get the input data  
   
# Basic Usage is going to be  
# cmd.sh inputfile segmentlength  
   
INPUTFILE=$1  
SEGLENGTH=$2  
if ! [ -z "$3" ]  
then  
OUTPUT_DIRECTORY=$3  
fi  
   
# Check we've got the arguments we need # Check we've got the arguments we need
if [ "$INPUTFILE" == "" ] || [ "$SEGLENGTH" == "" ] if [ "$INPUTFILE" == "" ] || [ "$SEGLENGTH" == "" ]
then then
print_usage print_usage
fi fi
   
   
   
# FFMpeg is a pre-requisite, so let check for it # FFMpeg is a pre-requisite, so let check for it
if hash ffmpeg 2> /dev/null if hash $FFMPEG 2> /dev/null
then then
# FFMpeg exists # FFMpeg exists
echo "ffmpeg command found.... continuing" echo "ffmpeg command found.... continuing"
else else
# FFMPeg doesn't exist, uh-oh! # FFMPeg doesn't exist, uh-oh!
echo "Error: FFmpeg doesn't appear to exist in your PATH. Please addresss and try again" echo "Error: FFmpeg doesn't appear to exist in your PATH. Please addresss and try again"
exit 1 exit 1
fi fi
   
   
# Now we want to make sure out input file actually exists # Now we want to make sure out input file actually exists
if ! [ -f "$INPUTFILE" ] if ! [ -f "$INPUTFILE" ]
then then
echo "Error: You gave me an incorrect filename. Please re-run specifying something that actually exists!" echo "Error: You gave me an incorrect filename. Please re-run specifying something that actually exists!"
exit 1 exit 1
fi fi
   
   
   
# OK, so from here, what we want to do is to split the file into appropriately sized chunks,  
# re-encoding each to H.264 with MP3 audio, all to go into an MPEG2TS container  
#  
# The protocol appears to support MP4 as well though, so we may well look at that later.  
#  
# Essentially we want to create the chunks by running  
#  
# ffmpeg -i "$INPUTFILE" -vcodec libx264 -acodec mp3 -ss "START_POINT" -t "$SEGLENGTH" -f mpegts $OUTPUT_DIRECTORY/"$INPUTFILE"_"$N".ts  
   
# First we need the duration of the video  
DURATION=$($FFMPEG -i "$INPUTFILE" 2>&1 | grep Duration | cut -f 4 -d ' ')  
   
# Now we need to break out the duration into a time we can use  
DUR_H=$(echo "$DURATION" | cut -d ':' -f 1)  
DUR_M=$(echo "$DURATION" | cut -d ':' -f 2)  
DUR_X=$(echo "$DURATION" | cut -d ':' -f 3 | cut -d '.' -f 1)  
   
# Calculate the duration in seconds  
DURATION_S=$(expr \( $DUR_H \* 60 + $DUR_M \) \* 60 + $DUR_X)  
   
   
# Check we've not got empty media  
if [ "$DURATION_S" == "0" ]  
then  
echo "You've given me an empty media file!"  
exit 1  
fi  
   
   
# Now we've got our Duration, we need to work out how many segments to create  
N='1'  
START_POS='0'  
let 'N_FILES = DURATION_S / SEGLENGTH + 1'  
   
# Check output directory exists otherwise create it # Check output directory exists otherwise create it
if [ ! -w $OUTPUT_DIRECTORY ] if [ ! -w $OUTPUT_DIRECTORY ]
then then
echo "Creating $OUTPUT_DIRECTORY" echo "Creating $OUTPUT_DIRECTORY"
mkdir -p $OUTPUT_DIRECTORY mkdir -p $OUTPUT_DIRECTORY
fi fi
   
# For now, INPUTFILENAME is going to == INPUTFILE # Pulls file name from INPUTFILE which may be an absolute or relative path.
# Later, we'll change so that INPUTFILE could be an absolute path, whilst INPUTFILENAME will just be the filename INPUTFILENAME=${INPUTFILE##*/}
INPUTFILENAME=$INPUTFILE  
   
# Create the M3U8 file  
create_m3u8 "$INPUTFILENAME" "$SEGLENGTH"  
   
# Finally, lets build the output filename format # Finally, lets build the output filename format
OUT_NAME=$INPUTFILENAME"_%03d.ts" OUT_NAME=$INPUTFILENAME"_%05d.ts"
   
# Processing Starts # Processing Starts
  $FFMPEG -i "$INPUTFILE" \
  -loglevel error -y \
  -vcodec "$VIDEO_CODEC" \
  -acodec "$AUDIO_CODEC" \
  -threads "$NUMTHREADS" \
  -map 0 \
  -flags \
  -global_header \
  -f segment \
  -segment_list "$OUTPUT_DIRECTORY/$INPUTFILENAME.m3u8" \
  -segment_time "$SEGLENGTH" \
  -segment_format mpeg_ts \
  $FFMPEG_FLAGS \
  $OUTPUT_DIRECTORY/"$OUT_NAME" || exit 1
   
while [ "$START_POS" -lt "$DURATION_S" ]  
do  
   
OUTPUT=$( printf "$OUT_NAME" "$N" )  
echo "Creating $OUTPUT ($N/$N_FILES)..."  
$FFMPEG -i "$INPUTFILE" -loglevel quiet -vcodec libx264 -acodec mp3 -ss "$START_POS" -t "$SEGLENGTH" -f mpegts $OUTPUT_DIRECTORY/"$OUTPUT"  
   
let "N = N + 1"  
let "START_POS = START_POS + SEGLENGTH"  
   
# If we're on the last segment, the duration may be less than the seglenth, so we need to reflect this in the m3u8  
if ! [ "$START_POS" -lt "$DURATION_S" ]  
then  
SEG_DURATION=$($FFMPEG -i $OUTPUT_DIRECTORY/"$OUTPUT" 2>&1 | grep Duration | cut -f 4 -d ' ')  
# Now we need to break out the duration into a time we can use  
DUR_H=$(echo "$SEG_DURATION" | cut -d ':' -f 1)  
DUR_M=$(echo "$SEG_DURATION" | cut -d ':' -f 2)  
DUR_X=$(echo "$SEG_DURATION" | cut -d ':' -f 3 | cut -d '.' -f 1)  
   
# Calculate the duration in seconds  
let "SEGLENGTH = ( DUR_H * 60 + DUR_M ) * 60 + DUR_X"  
fi  
   
# Append the file reference to the M3U8  
append_segment "$INPUTFILENAME" "$SEGLENGTH" "$OUTPUT"  
   
done  
   
# Add the close tag (ffplay gives some weird behaviour without this!)  
close_m3u8 "$INPUTFILENAME"  
   
file:a/README.md -> file:b/README.md
HLS-Stream-Creator HLS-Stream-Creator
================== ==================
   
Introduction Introduction
------------- -------------
   
HLS-Stream-Creator is a simple BASH Script designed to take a media file, segment it and create an M3U8 playlist for serving using HLS. HLS-Stream-Creator is a simple BASH Script designed to take a media file, segment it and create an M3U8 playlist for serving using HLS.
There are numerous tools out there which are far better suited to the task, and offer many more options. This project only exists because I was asked to look There are numerous tools out there which are far better suited to the task, and offer many more options. This project only exists because I was asked to look
into HTTP Live Streaming in depth, so after reading the [IETF Draft](http://tools.ietf.org/html/draft-pantos-http-live-streaming-11 "HLS on IETF") I figured I'd start with the basics by creating a script to encode arbitrary video into a VOD style HLS feed. into HTTP Live Streaming in depth, so after reading the [IETF Draft](http://tools.ietf.org/html/draft-pantos-http-live-streaming-11 "HLS on IETF") I figured I'd start with the basics by creating a script to encode arbitrary video into a VOD style HLS feed.
   
   
   
Usage Usage
------ ------
   
Usage is incredibly simple Usage is incredibly simple
   
``` ```
./HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output'] ./HLS-Stream-Creator.sh -i [inputfile] -s [segmentlength(seconds)] -o [outputdir]
   
   
  Deprecated Legacy usage:
  HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output']
   
``` ```
   
So to split a video file called *example.avi* into segments of 10 seconds, we'd run So to split a video file called *example.avi* into segments of 10 seconds, we'd run
   
``` ```
./HLS-Stream-Creator.sh example.avi 10 ./HLS-Stream-Creator.sh -i example.avi -s 10
``` ```
   
   
   
Output Output
------- -------
   
As of version 1, the HLS resources will be output to the directory *output*. These will consist of video segments encoded in H.264 with MP3 audio (should be AAC really, but I'd compiled *ffmpeg* without) and an m3u8 file in the format As of version 1, the HLS resources will be output to the directory *output*. These will consist of video segments encoded in H.264 with AAC audio and an m3u8 file in the format
   
>\#EXTM3U >\#EXTM3U
>\#EXT-X-MEDIA-SEQUENCE:0 >\#EXT-X-MEDIA-SEQUENCE:0
>\#EXT-X-VERSION:3 >\#EXT-X-VERSION:3
>\#EXT-X-TARGETDURATION:10 >\#EXT-X-TARGETDURATION:10
>\#EXTINF:10, no desc >\#EXTINF:10, no desc
>example_001.ts >example_00001.ts
>\#EXTINF:10, no desc >\#EXTINF:10, no desc
>example_002.ts >example_00002.ts
>\#EXTINF:10, no desc >\#EXTINF:10, no desc
>example_003.ts >example_00003.ts
>\#EXTINF:5, no desc >\#EXTINF:5, no desc
>example_004.ts >example_00004.ts
>\#EXT-X-ENDLIST >\#EXT-X-ENDLIST
   
   
   
   
   
   
Using a Specific FFMPEG binary Using a Specific FFMPEG binary
------------------------------- -------------------------------
   
There may be occasions where you don't want to use the *ffmpeg* that appears in PATH. At the top of the script, the ffmpeg command is defined, so change this to suit your needs There may be occasions where you don't want to use the *ffmpeg* that appears in PATH. At the top of the script, the ffmpeg command is defined, so change this to suit your needs
   
``` ```
FFMPEG='/path/to/different/ffmpeg' FFMPEG='/path/to/different/ffmpeg'
``` ```
   
   
  Additional Environment Variables
  -------------------------------
   
  There are few environment variables which can control the ffmpeg behaviour.
   
  * `VIDEO_CODEC` - The encoder which will be used by ffmpeg for video streams. Examples: _libx264_, _nvenc_
  * `AUDIO_CODEC` - Encoder for the audio streams. Examples: _aac_, _libfdk_acc_, _mp3_, _libfaac_
  * `NUMTHREADS` - A number which will be passed to the `-threads` argument of ffmpeg. Newer ffmpegs with modern libx264 encoders will use the optimal number of threads by default.
  * `FFMPEG_FLAGS` - Additional flags for ffmpeg. They will be passed without any modification.
   
  Example usage:
   
  ```
  export VIDEO_CODEC="nvenc"
  export FFMPEG_FLAGS="-pix_fmt yuv420p -profile:v"
  ./HLS-Stream-Creator.sh example.avi 10
  ```
   
License License
-------- --------
   
HLS-Stream-Creator is licensed under the [BSD 3 Clause License](http://opensource.org/licenses/BSD-3-Clause) and is Copyright (C) 2013 [Ben Tasker](http://www.bentasker.co.uk) HLS-Stream-Creator is licensed under the [BSD 3 Clause License](http://opensource.org/licenses/BSD-3-Clause) and is Copyright (C) 2013 [Ben Tasker](http://www.bentasker.co.uk)
   
   
  Issue Tracking
  ----------------
   
  Although the Github issue tracker can be used, the bulk of project management (such as it is) happens in JIRA. See [projects.bentasker.co.uk](http://projects.bentasker.co.uk/jira_projects/browse/HLS.html) for a HTML mirror of the tracking.